package integrationtest;

import org.junit.*;
import com.meterware.httpunit.*;

public class HttpUnitTest
{
   @Test
   public void test() throws Exception
   {
      String port = System.getProperty( "port" );
      test( port, "1", "2", "3.0" );
   }

   public String test( String port, String wert1, String wert2, String ergebnis ) throws Exception
   {
      WebConversation conversation = new WebConversation();
      WebRequest      request = new GetMethodWebRequest( "http://localhost:" + port + "/MvnHtmlIntTest/" );
      WebResponse     response = conversation.getResponse( request );
      Assert.assertEquals( "ReturnCode: ", 200, response.getResponseCode() );
      Assert.assertEquals( "ReturnMsg: ", "OK", response.getResponseMessage() );
      Assert.assertEquals( "Titel: ", "Startseite", response.getTitle() );
      response = response.getLinkWithName( "BerechnungsFormular" ).click();
      Assert.assertEquals( "Titel: ", "Webseite mit Berechnungsformular", response.getTitle() );
      WebForm form = response.getFormWithName( "meinFormular" );
      form.setParameter( "wert1", wert1 );
      form.setParameter( "wert2", wert2 );
      form.getSubmitButton( "berechne" ).click();
      response = conversation.getCurrentPage();
      form = response.getFormWithName( "meinFormular" );
      String e = form.getParameterValue( "ergebnis" );
      if( ergebnis != null ) { Assert.assertEquals( "Ergebnis: ", ergebnis, e ); }
      return e;
   }
}
