@title run-SonarQubeUndSiteReport-all.bat
cls
@echo.
@echo -------------------------------------------------------------------------
@echo run-SonarQubeUndSiteReport-all.bat
@echo -------------------------------------------------------------------------
@echo.

set _SONAR_START_BAT=\Tools\SonarQube\bin\windows-x86-64\StartSonar.bat
set _SITE_REPORTS_DIR=\MeineSiteReports
set _IGNORED_DIRS=MvnAppSrvFailsaveIntTest MvnAppSrvIntTest MvnMultiProj1 MvnMultiProj2 MvnMultiProj3 MvnSign SonarQubeUndSiteReport
@if not exist "%_SONAR_START_BAT%" goto _Fehler
@if not exist "%_SITE_REPORTS_DIR%" md "%_SITE_REPORTS_DIR%"
@if not exist "%_SITE_REPORTS_DIR%" goto _Fehler

netstat -an | find "0.0.0.0:9000"
@if not errorlevel 1 goto _Sonar_Server_fertig
start "SonarQube" "%_SONAR_START_BAT%"
:_Warte_Sonar_Server
@echo Warten auf den SonarQube-Server ...
@ping -n 5 127.0.0.1>nul
@netstat -an | find "0.0.0.0:9000"
@if errorlevel 1 goto _Warte_Sonar_Server
:_Sonar_Server_fertig
start http://localhost:9000

pushd .
cd ..
@echo off

FOR /F %%i in ('dir /B /A:D') DO (
  echo.
  call :checkignored %%i
  if not errorlevel 1 (
    if exist %%i\pom.xml (
      echo.
      echo -------------------------------------------------------------------------
      echo Projektverzeichnis: %%i
      echo -------------------------------------------------------------------------
      echo on
      cd %%i
      echo.
      echo ---- SonarQube fuer %%i:
      echo.
      call mvn clean org.jacoco:jacoco-maven-plugin:prepare-agent install -Dmaven.test.failure.ignore=true
      call mvn sonar:sonar
      if errorlevel 1 goto _Fehler
      @echo on
      echo.
      echo ---- Site-Reports fuer %%i:
      echo.
      if exist "%_SITE_REPORTS_DIR%\%%i\site" rd /S /Q "%_SITE_REPORTS_DIR%\%%i\site"
      call mvn clean site
      if errorlevel 1 goto _Fehler
      echo on
      xcopy target\site "%_SITE_REPORTS_DIR%\%%i\site\" /S
      if exist %_SITE_REPORTS_DIR%\%%i\site\project-info.html (
         start %_SITE_REPORTS_DIR%\%%i\site\project-info.html
      )
      @echo.

      cd ..
      echo off
    )
  )
)

@echo 
start http://localhost:9000
@goto _fertig

:checkignored
FOR /D %%j in (%_IGNORED_DIRS%) DO IF "%1"=="%%j" EXIT /B 1
exit /B 0

:_Fehler
@echo.
@echo -------------------------------------------------------------------------
@echo !!! Fehler !!!
@echo -------------------------------------------------------------------------
@echo 
pause

:_fertig
@echo on
@echo.
popd
@echo.
